#define rxpin 3
#define txpin 2
#define settle 100
#define samples 100

void setup() {
  pinMode(txpin, OUTPUT);
  pinMode(4, OUTPUT);
}

long int average() {
  long int up, down, avg;
   avg = 0;
   noInterrupts();
   for (int i = 0; i < samples; i++) {
      digitalWrite(txpin, HIGH);
      up = analogRead(rxpin);
      delayMicroseconds(settle);
      digitalWrite(txpin, LOW);
      down = analogRead(rxpin);
      delayMicroseconds(settle);
      avg += up - down;
   }
   interrupts();
   return avg;
}

void betterEst() {
  int counter = 0;
  for (int i = 0; i < 10; i++) {
    long int avg = average();
    if (avg > 15000) counter++;
    else counter--;
  }
  if (counter >= -5) digitalWrite(4, HIGH);
  else digitalWrite(4, LOW);
}

void instantCheck() {
  long int avg = average();
  if (avg > 9000) digitalWrite(4, HIGH);
  else digitalWrite(4, LOW);
}
void analogLED() {
  long int avg = average();
  int newAvg = map(avg, 10000, 15000, 0, 255);
  analogWrite(4, 255 - newAvg);
}

void loop() {
   //instantCheck();
   //betterEst();
   analogLED();
}
